# Contract for the Mon::List monad, for use with the Contracts gem
# For example:
# <tt>Contract C::List[Num] => C::List[Num]
# def listSquare(l)
#   l.bind { |i| i * i }
# end</tt>
# will work only for listSquare(Mon::List[1, 2, 3, 4]). If passed
# anything (or returning anything) other than a Mon::List, a
# ContractViolation will be thrown.

module Mon
  module Contract
    require_relative 'monad_contract'
    
    class List < MonadContract
      def valid?(val)
        # Should be a List whose elements satisfy the given contract
        val.is_a?(Mon::M::List) and (val._.all? { |el| valid_nested_contract?(el) })
      end
    end
  end
end
