# Contract for the Mon::React monad, for use with the Contracts gem
# For example:
# <tt>Contract C::React[Num] => C::React[Num]
# def reactSquare(l)
#   l.bind { |i| i * i }
# end</tt>
# will work only for (eg) reactSquare(Mon::React[3]).
# If passed anything (or returning anything) other than a Mon::React, a
# ContractViolation will be thrown.

module Mon
  module Contract
    require_relative 'monad_contract'
    
    class React < MonadContract
      def valid?(val)
        # Should be a React (i.e. success or failure), and if it's a 
        # success, the value should be valid re: the provided contract
        val.is_a?(Mon::M::React) and (valid_nested_contract?(val._))
      end
    end
  end
end
