# Base class for Mon monads. Do not instantiate.

module Mon
  module Monad
    module ChainableMonad
      def method_missing(name, *args, &fun)
        self.bind { |o| o.send(name, *args, &fun) }
      end

      def respond_to? name
        self._canBind?(name)
      end

      def _
        self.unwrap
      end

      def coerce(other)
        return self, other
      end
    end
  end
end
